#push功能的代理选择用哪种推送工具1.个推 2.小米 3.华为
class PushToolClient
  
  def initialize(opts={})
    opts = HashWithIndifferentAccess.new(opts)
    @user_ids = opts[:user_ids]
    @opts = opts
  end

  def do_push
    # Settings.platform = @opts[:app_type] || Settings::DEFAULT

    igetui_android_client_ids, igetui_ios_client_ids, xiaomi_client_ids, huawei_client_ids = fetch_client_ids_group

    if igetui_android_client_ids.present?
      igetui_android_client_ids.each_pair do |app_type, ids|
        Igetui::Pusher.new(ids, @opts.merge(device_platform: 'android', app_type: app_type)).perform
        # NotificationStatistic.static_notification(@opts.merge(app_type: app_type), ids,'igetui', 'android' )
      end
    end
 
    if igetui_ios_client_ids.present?
      igetui_ios_client_ids.each_pair do |app_type, ids|
        Igetui::Pusher.new(ids, @opts.merge(device_platform: 'ios', app_type: app_type)).perform
        # NotificationStatistic.static_notification(@opts.merge(app_type: app_type), ids,'igetui', 'ios' )
      end
    end

    #现在好像不用了
    # Push::IgetuiIos.push(@push_collections[:igetui_ios], @opts) if @push_collections[:apns].present?
    # Push::IgetuiAndroid.push(@push_collections[:igetui_android], @opts) if @push_collections[:apns].present?


    if xiaomi_client_ids.present?
      xiaomi_client_ids.each_pair do |app_type, ids|
        message = @opts[:message].merge(@opts[:message][:transmission_content] || {})
        Xiaomi::Pusher.new(ids, message, app_type).perform
        # NotificationStatistic.static_notification(@opts.merge(app_type: app_type), ids,'xiaomi')
      end
  
    end

    if huawei_client_ids.present?
      huawei_client_ids.each_pair do |app_type, ids|
        message = @opts[:message].merge(@opts[:message][:transmission_content] || {})
        Huawei::Pusher.new(ids, message, app_type).perform
        # NotificationStatistic.static_notification(@opts.merge(app_type: app_type), ids,'huawei')
      end
    end
  end
  
  def fetch_client_ids_group
    igetui_android_client_ids = {}; igetui_ios_client_ids = {}; xiaomi_client_ids = {}; huawei_client_ids = {}
    
    if (@opts[:device_ids_opts].is_a? Hash) && @user_ids.blank? && @opts[:app_type].present?
      push_devices = @opts[:device_ids_opts].keys.map(&:to_s)
      if push_devices.include? "igetui"
        igetui_android_client_ids = {"#{@opts[:app_type]}" => @opts[:device_ids_opts][:igetui]} if @opts[:igetui_opts][:device_platform] == 'android'
        igetui_ios_client_ids = {"#{@opts[:app_type]}" =>@opts[:device_ids_opts][:igetui]} if @opts[:igetui_opts][:device_platform] == 'ios'
      end

      huawei_client_ids = {"#{@opts[:app_type]}" => @opts[:device_ids_opts][:huawei]} if push_devices.include? "huawei"
      xiaomi_client_ids = {"#{@opts[:app_type]}" =>  @opts[:device_ids_opts][:xiaomi]} if push_devices.include? "xiaomi"  
    else
      push_device_collections = UserDevice.where(user_id: @user_ids).group_by(&:platform)

      igetui_push_device_collections = push_device_collections['igetui'].group_by(&:device_platform) if push_device_collections['igetui'].is_a? Array
      if igetui_push_device_collections.is_a? Hash
        if igetui_push_device_collections['android'].is_a? Array
          
          igetui_app_type_group = igetui_push_device_collections['android'].group_by(&:app_type)
          igetui_app_type_group.each_pair{|k,v| igetui_android_client_ids.merge!("#{k}"=> v.map(&:client_id))}
        end

        if igetui_push_device_collections['ios'].is_a? Array

          igetui_app_type_group = igetui_push_device_collections['ios'].group_by(&:app_type)
          igetui_app_type_group.each_pair{|k,v| igetui_ios_client_ids.merge!("#{k}"=> v.map(&:client_id))}
        end
      end

      if push_device_collections['xiaomi'].is_a? Array
        xiaomi_client_group = push_device_collections['xiaomi'].group_by(&:app_type)
        xiaomi_client_group.each_pair{|k,v| xiaomi_client_ids.merge!("#{k}"=> v.map(&:client_id))}
      end

      if push_device_collections['huawei'].is_a? Array
        huawei_client_ids = push_device_collections['huawei'].group_by(&:app_type)
        huawei_client_ids.each_pair{|k,v| huawei_client_ids.merge!("#{k}"=> v.map(&:client_id))}
      end
    end
    
    [igetui_android_client_ids, igetui_ios_client_ids, xiaomi_client_ids, huawei_client_ids]
  end
end